//#-hidden-code
//
//  Copyright © 2020 Apple Inc. All rights reserved.
//

import PlaygroundSupport
import Setup
import Canvas
import Scenes
import UIKit
import SpriteKit
import SwansQuest
import PlaygroundSupport

PlaygroundPage.current.liveView = PlaygroundContext.liveViewController
PlaygroundContext.liveViewController.backgroundImage = #imageLiteral(resourceName: "LiveViewBackground.png")

Canvas.load(customFont: "Songkhla-Regular")

//#-end-hidden-code
//#-editable-code
// Touch "Run My Code" to continue your quest...

func performance(owner: Assessable) {
    // TODO: Play an instrument using the calls the Lizard told you about
    
    // Let the Lizard know when you're done
    owner.endPerformance()
}

//#-end-editable-code
//#-hidden-code
let passages = [
    "The instruments in this chest are magnificent. I’ve heard stories from the Ancient Migration, but I never thought I’d get to hold one.",
    
    "The different instruments also explains the multi-part harmony on this scroll. You’ll need to play two different instruments simultaneously to pass this challenge.",
    
    "You’re gonna need some different magic to pull this off. I think you should build a step sequencer.\n\nThat’ll keep our timing loop simple.",
    
    "A step sequencer is a series of instrument tracks, laid out in a grid of frames called ‘steps’. On each frame, each track’s instrument can play a note.",
    
    "Look in Sequencer.swift. There you’ll find a formula for tracks, called ‘TrackProtocol’. Build a ‘Track’ type that conforms to it. You’re going to need at least two of them for the Swan’s song.",
    
    "In your ‘Timer’ loop, iterate over each of your ‘Tracks’ to play the note for its assigned instrument. Speaking on notes, I have a different type for this challenge.",
    
    "Look at the ‘MIDINotes’ enum I’ve built for you in Sequencer.swift. Using this, you can play a track’s instrument with the following spell:\n\n\tplayInstrument(.piano, note: MIDINotes.C2)",
    
    "Finally, don’t forget to call ‘endPerformance()’ when you finish playing the tune. This lets the Swan know you’re done, so their advisors can judge your performance.",
    
    "Try playing an instrument right now. To see the available instruments, use the completions tablet at the bottom of your screen.",
    
    "I’m listening..."
]
let script = Script(passages, success: "Yes, that’s it. I think you’re ready to build the rest of the sequencer.", tryAgain: "Hmm, something went wrong. Let’s try that again.")


let conversation = Conversation(with: .lizard, using: script) {
    // Assessment: Check to see if playInstrument was called.
    let checker = ContentsChecker(contents: PlaygroundPage.current.text)
    if checker.functionCallCount(forName: "playInstrument") > 0 {
        return true
    }
    return false
}
conversation.performance = performance
conversation.scrollAppearsAtIndex = (0, .challenge4)

let titleScene = Title()
titleScene.loadingDescription = "Welcome to Swan‘s Quest, a programming adventure where you control the fate of our Hero by solving challenges with code. In this final adventure, our Hero returns to the Lizard with a chest full of ancient items and another musical scroll. Press the play button when you're ready."

let hut = Hut(with: .scrollChest)
hut.loadingDescription = "The turtle returns to the Lizard, this time with a large chest of ancient items and an even more complex musical scroll."

conversation.loadingDescription = "Let's see if the Lizard can help."

let caveEntrance = CaveEntrance(with: .scrollChest)
caveEntrance.loadingDescription = "Carrying the instruments and scroll, our Hero heads back into the Cave."

let endTitle = TextScene(says: "The adventure concludes\non the next page...")
endTitle.loadingDescription = "Turn the page to give your final performance for the Swan."

// Scene Order: (Title, Hut, Lizard conversation w/scroll-chest, CaveEntrance, end)
var runner = Runner([ titleScene, hut, conversation, caveEntrance, endTitle ])


runner.start()

//#-end-hidden-code
